/*
City of Saint Paul Open Source License

LICENSE

Copyright © 2006 City of Saint Paul, Minnesota. 

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following terms and conditions:

1.The above copyright notice and this permission notice shall be included in all copies of this Software or works derived from this Software.
2.Whenever a Recipient distributes or redistributes the Software, a copy of this agreement must be included with each copy of the Software
3.If Recipient distributes or redistributes the Software in any form other than source code, Recipient must also make the source code freely available, and must provide with each copy of the Software information on how to obtain the source code in a reasonable manner on or through a medium customarily used for software exchange
4.A Recipient may not make any representation in the Software or in any promotional, advertising or other material that may be construed as an endorsement by the City of Saint Paul of any product or service provided by Recipient, or that may seek to obtain commercial advantage by the fact of the City of Saint Paul’s participation in this Agreement.

DISCLAIMER OF WARRANTIES AND LIABILITIES; WAIVER AND INDEMNIFICATION

No Warranty:  The Software is provided “as is” without any warranty of any kind, either expressed, implied, or statutory, including, but not limited to, any warranty that the Software will conform to specifications, any implied warranties of merchantability, fitness for a particular purpose, or freedom from infringement, any warranty that the Software will be error free, or any warranty that documentation, if provided, will conform to the Software. This agreement does not, in any manner, constitute an endorsement by the City of Saint Paul or any prior recipient of any results, resulting designs, hardware, software products or any other applications resulting from use of the Software. Further, the City of Saint Paul disclaims all warranties and liabilities regarding third-party software, if present in the original Software, and distributes it “as is.”

Waiver and Indemnity:  Recipient agrees to waive any and all claims against the City of Saint Paul, its contractors and subcontractors, as well as any prior recipient.  If recipient's use of the Software results in any liabilities, demands, damages, expenses or losses arising from such use, including any damages from products based on, or resulting from, recipient's use of the Software, recipient shall indemnify and hold harmless the City of Saint Paul, it’s contractors and subcontractors, as well as any prior recipient, to the extent permitted by law. Recipient's sole remedy for any such matter shall be the immediate, unilateral termination of this agreement.

SUPPORT STATEMENT 

The Software is freely provided by the City of Saint Paul as a public service.  The recipient is herby notified that the provision and distribution of the Software should in no way be construed to mean that the City of Saint Paul is obligated to provide any level of support for the Software, now or in the future.  Support in this context shall be construed to mean providing coordination, technical assistance, responding to questions, releasing bug fixes, providing future releases, or otherwise obligating the City of Saint Paul to commit resources to maintain this Software or assist in its implementation by any person or entity.  The City of Saint Paul may, at it’s sole option, and without notice or obligation to the recipients, provide varying levels of support for the Software or terminate the agreement.  Provision of such support shall not alter the condition that the Software is provided without support as stated above.
*/

function zoomInUp(evnt) {
	if(window.event) { evnt = window.event; }

	var zoomLine = new LineSegment(zoomStartPoint, zoomEndPoint);

	if(ZoomBox && zoomLine.getLength() > 25) {
		var widthPercent =zoomLine.getWidth()  / mapSize.x;
		var heightPercent =zoomLine.getHeight() / mapSize.y;
		if(widthPercent < heightPercent) {
			widthPercent = heightPercent;
		}
		var midPoint = zoomLine.getMidPoint();
		zoomTo(midPoint.x, midPoint.y, widthPercent);
	} else {
		zoomToEvent(evnt, .5);
	}
	zoomStartPoint = null;
	zoomEndPoiint = null;
}

function zoomOutUp(evnt) {
	if(window.event) { evnt = window.event; }
	ZoomBox = null; zoomStartPoint = null; zoomEndPoint = null;
	zoomToEvent(evnt, 2);
}

function zoomOutDown(evnt) {
	if(window.event) { evnt = window.event; }
	zoomStartPoint = new Point(evnt.clientX, evnt.clientY);
}

function zoomInDown(evnt) {
	if(window.event) { evnt = window.event; }
	zoomStartPoint = new Point(evnt.clientX, evnt.clientY);
	if(ZoomBox == null) {
		ZoomBox = document.createElement('div');
		ZoomBox.className = 'ZoomBox';
		ZoomBox.style.position = 'absolute';
		ZoomBox.style.border = 'solid 2px red';
		ZoomBox.style.zIndex = 49;
		document.getElementsByTagName('body')[0].appendChild(ZoomBox);
	}
}

function zoomInMove(evnt) {
	if(window.event) { evnt = window.event; }
	if(zoomStartPoint && ZoomBox) {
		zoomEndPoint = new Point(evnt.clientX, evnt.clientY);
		var testLine = new LineSegment(zoomStartPoint, zoomEndPoint);
			var StartPoint = testLine.pointA;
			var EndPoint = testLine.pointB;
			ZoomBox.style.left = testLine.minX() + 'px';
			ZoomBox.style.top = testLine.minY() + 'px';
			ZoomBox.style.width = testLine.getWidth() + 'px';
			ZoomBox.style.height = testLine.getHeight() + 'px';
	}
}

function zoomPanDown(evnt) {
	if(window.event) { evnt = window.event; }
	zoomDiff = null;
	zoomStartPoint = new Point(evnt.clientX, evnt.clientY);
}

function zoomPanUp(evnt) {
	if(window.event) { evnt = window.event; }
	zoomEndPoint = new Point(evnt.clientX, evnt.clientY);
	if(zoomStartPoint != null) {
		var zoomStartPointCopy = zoomStartPoint;
		zoomStartPoint = null;
		var l = getFirstLayer().getImageObject();
		var diffX = l.offsetLeft - minImageCoords.x;
		var diffY = l.offsetTop - minImageCoords.y;
		var diffP = new Point(diffX,diffY);

		var newCenterPoint = new Point();
		newCenterPoint.x = mapCenterPoint.x - diffX * mapScale;
		newCenterPoint.y = mapCenterPoint.y + diffY * mapScale;
		changePointScale(newCenterPoint, mapScale);
		//logDebugMessage('Pan', true, 'Panning to New Center Point: '+mapCenterPoint.toString(',')+' with Scale: '+mapScale);
		updateAllLayers();
	}
}


function zoomPanMove(evnt) {
	if(window.event) { evnt = window.event; }
	if(zoomStartPoint != null) {
		for(var layer in layerObjs) {
			if(layerObjs[layer].displayable) {
				var img = layerObjs[layer].getImageObject();
				img.style.left = (minImageCoords.x + evnt.clientX - zoomStartPoint.x)+'px';
				img.style.top = (minImageCoords.y + evnt.clientY - zoomStartPoint.y)+'px';
			}
		}
	}
}


function loadZoomIn() {
	var box = document.getElementById('MapTool');
	loadZoomToolFamily(box, zoomInDown, zoomInUp, zoomInMove, null);
}

function loadZoomOut() {
	var box = document.getElementById('MapTool');
	loadZoomToolFamily(box, zoomOutDown, zoomOutUp, null, null);
}

function loadZoomPan() {
	var box = document.getElementById('MapTool');
	loadZoomToolFamily(box, zoomPanDown, zoomPanUp, zoomPanMove, zoomPanUp);
}

function loadDataInspector() {
	var box = document.getElementById('MapTool');
	loadZoomToolFamily(box, null, null, AllPopups.getPopupsUsingShape, null);
}

function loadEmptyZoomTool() {
	var box = document.getElementById('MapTool');
	loadZoomToolFamily(box,null, null,null,null);
}

function saveZoomTool() {
	var box = document.getElementById('MapTool');
	box._onmousedown = box.onmousedown;
	box._onmouseup = box.onmouseup;
	box._onmousemove = box.onmousemove;
	box._onmouseout = box.onmouseout;
}

function restoreZoomTool() {
	var box = document.getElementById('MapTool');
	box.onmousedown = box._onmousedown;
	box.onmouseup = box._onmouseup;
	box.onmousemove = box._onmousemove;
	box.onmouseout = box._onmouseout;
}
